var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key2, value) => key2 in obj ? __defProp(obj, key2, { enumerable: true, configurable: true, writable: true, value }) : obj[key2] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key2 of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key2) && key2 !== except)
        __defProp(to, key2, { get: () => from[key2], enumerable: !(desc = __getOwnPropDesc(from, key2)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  CHANNEL_SPECIFIC_LUM: () => CHANNEL_SPECIFIC_LUM,
  CMYK: () => CMYK,
  CSS_COLOR_PROPERTY_KEYS: () => CSS_COLOR_PROPERTY_KEYS,
  CSS_PSEUDO_CLASSES: () => CSS_PSEUDO_CLASSES,
  HUE_STRUCTURES: () => HUE_STRUCTURES,
  Luum: () => Luum,
  PAINT_MY_WAGON_RED: () => PAINT_MY_WAGON_RED,
  RED: () => RED,
  UI: () => UI,
  WAYFORGE_CORE_COLORS: () => WAYFORGE_CORE_COLORS,
  WAYFORGE_CORE_COLOR_NAMES: () => WAYFORGE_CORE_COLOR_NAMES,
  amp: () => amp,
  ampBy: () => ampBy,
  channelsToSpec: () => channelsToSpec_default,
  contrastMax: () => contrastMax,
  contrastSoft: () => contrastSoft,
  contrastStrong: () => contrastStrong,
  hexToChannels: () => hexToChannels_default,
  hexToSpec: () => hexToSpec_default,
  hueFromChannels: () => hueFromChannels_default,
  hueToRelativeChannels: () => hueToRelativeChannels_default,
  identifyHue: () => identifyHue,
  interpolate: () => interpolate_default,
  isCssColorPropertyKey: () => isCssColorPropertyKey,
  isCssPseudoClass: () => isCssPseudoClass,
  isFilter: () => isFilter,
  isFilterPoint: () => isFilterPoint,
  isLuumCssAttribute: () => isLuumCssAttribute,
  isLuumCssRule: () => isLuumCssRule,
  isLuumScssNestedRule: () => isLuumScssNestedRule,
  isLuumScssPseudoClassRule: () => isLuumScssPseudoClassRule,
  isLuumScssRule: () => isLuumScssRule,
  isLuumSpec: () => isLuumSpec,
  isLuumSpecModifier: () => isLuumSpecModifier,
  lumFromChannels: () => lumFromChannels_default,
  luumToCss: () => luumToCss,
  maxSatForHueInFilter: () => maxSatForHueInFilter_default,
  maybe: () => maybe,
  mute: () => mute,
  muteBy: () => muteBy,
  normalizeHex: () => normalizeHex_default,
  offset: () => offset,
  palettes: () => palettes,
  resetColor: () => resetColor,
  satFromChannels: () => satFromChannels_default,
  setHue: () => setHue,
  setLum: () => setLum,
  setSat: () => setSat,
  shade: () => shade,
  shadeBy: () => shadeBy,
  specToHex: () => specToHex_default,
  specToHexFixLimit: () => specToHexFixLimit_default,
  specificLumFromHue: () => specificLumFromHue_default,
  splitBy: () => splitBy,
  tetra: () => tetra,
  tint: () => tint,
  tintBy: () => tintBy,
  trifactory: () => trifactory,
  trine: () => trine,
  unfiltered: () => unfiltered
});
module.exports = __toCommonJS(src_exports);

// src/constants/index.ts
var HUE_STRUCTURES = {
  none: [],
  polar: [180],
  split: [150, 210],
  trine: [120, 240],
  square: [90, 180, 270]
};
var CHANNEL_SPECIFIC_LUM = {
  R: 0.3,
  G: 0.5,
  B: 0.2
};

// src/constants/filters.ts
var unfiltered = [
  { sat: 255, hue: 0 },
  { sat: 255, hue: 360 }
];
var CMYK = [
  { sat: 255, hue: 55 },
  { sat: 127, hue: 120 },
  { sat: 255, hue: 200 },
  { sat: 255, hue: 205 },
  { sat: 170, hue: 240 },
  { sat: 230, hue: 270 },
  { sat: 210, hue: 300 },
  { sat: 255, hue: 320 }
];

// src/constants/schemes.ts
var UI = {
  state: {
    hover: {},
    active: {},
    disabled: {}
  },
  bg: {
    shade: 24,
    state: {
      base: {},
      hover: { shade: 18 },
      active: { shade: 32 },
      disabled: { shade: 32 }
    }
  },
  mg: {
    shade: 48
  },
  fg: {
    contrast: `soft`,
    state: {
      hover: { contrast: `harden` },
      active: { contrast: `harden` },
      disabled: { shade: 20 }
    }
  }
};
var trifactory = {
  PaletteModule: {
    contextColor: [{ resetColor: `#fee` }, { shade: 20 }],
    /*
      // NOTE: These state changes are localized to the current
      // object, and have no impact on children.
      states: {
        hover: [{tint: 10}, {shade: 22}],
      },
      */
    // NOTE: these variables get included into each child
    // as ex-<variable-name>
    variables: {
      bg: [],
      mg: [{ resetColor: 1 }, { shade: 10 }],
      fg: [{ contrast: `soft` }]
    },
    children: {
      Control: {
        // NOTE: All these colors start with the contextColor
        // and not with the ex-color from parent
        states: {
          base: {},
          hover: [{ tint: 12 }],
          active: [{ shade: 18 }]
        },
        variables: {
          bg: [{ shade: 24 }],
          mg: [{ shade: 48 }],
          fg: {
            // NOTE: All these colors start with a context of the
            // existing state of the parent.
            states: {
              base: [{ shade: 24 }, { contrast: `soft` }],
              hover: [{ shade: 24 }, { contrast: `soft` }],
              active: [{ shade: 24 }, { contrast: `hard` }]
            }
          }
        }
      }
    }
  }
};
var palettes = [
  {
    id: `PaletteName`,
    hex: `#f00`,
    states: [
      {
        id: `base`,
        hex: `#f00`,
        elements: [
          { id: `bg`, hex: `#f00` },
          { id: `mg`, hex: `#f00` },
          { id: `fg`, hex: `#f00` }
        ]
      },
      {
        id: `hover`,
        hex: `#f00`,
        elements: [
          { id: `bg`, hex: `#f00` },
          { id: `mg`, hex: `#f00` },
          { id: `fg`, hex: `#f00` }
        ]
      }
    ]
  }
];

// src/export/channelsToHex.ts
var channelsToHex = (channels) => `#${Object.values(channels).map((channel) => {
  let channelHex = channel.toString(16);
  if (channelHex.length === 1)
    channelHex = 0 + channelHex;
  return channelHex;
}).join(``)}`;
var channelsToHex_default = channelsToHex;

// ../anvl/src/number/clamp.ts
var clampInto = (min, max) => (value) => value < min ? min : value > max ? max : value;

// ../anvl/src/number/wrap.ts
var wrapInto = (min, max) => (value) => value < min ? max - (min - value) % (max - min) : min + (value - min) % (max - min);

// src/import/hueToRelativeChannels.ts
var hueToRelativeChannels_default = (hue) => {
  const hueWrapped = wrapInto(0, 360)(hue);
  const hueReduced = hueWrapped / 60;
  const hueInteger = Math.floor(hueReduced);
  const hueDecimal = hueReduced - hueInteger;
  const x = hueDecimal;
  const y = 1 - hueDecimal;
  switch (hueInteger) {
    case 0:
      return [1, x, 0];
    case 1:
      return [y, 1, 0];
    case 2:
      return [0, 1, x];
    case 3:
      return [0, y, 1];
    case 4:
      return [x, 0, 1];
    case 5:
      return [1, 0, y];
    default:
      throw new Error(`invalid hue served: ${hue}`);
  }
};

// src/solveFor/hueFromChannels.ts
var hueFromChannels = ({ R, G, B }) => {
  let hue = 0;
  if (R > G && G >= B)
    hue = 60 * (0 + (G - B) / (R - B));
  if (G >= R && R > B)
    hue = 60 * (2 - (R - B) / (G - B));
  if (G > B && B >= R)
    hue = 60 * (2 + (B - R) / (G - R));
  if (B >= G && G > R)
    hue = 60 * (4 - (G - R) / (B - R));
  if (B > R && R >= G)
    hue = 60 * (4 + (R - G) / (B - G));
  if (R >= B && B > G)
    hue = 60 * (6 - (B - G) / (R - G));
  return hue;
};
var hueFromChannels_default = hueFromChannels;

// src/solveFor/lumFromChannels.ts
var lumFromChannels = ({ R, G, B }) => {
  const lum = CHANNEL_SPECIFIC_LUM.R * R / 255 + CHANNEL_SPECIFIC_LUM.G * G / 255 + CHANNEL_SPECIFIC_LUM.B * B / 255;
  return lum;
};
var lumFromChannels_default = lumFromChannels;

// src/solveFor/maxSatForHueInFilter.ts
var maxSatForHueInFilter_default = (hue, filter) => {
  let maxSat = 255;
  const hueWrapped = wrapInto(0, 360)(hue);
  for (let a = -1, b = 0; b < filter.length; a++, b++) {
    a = wrapInto(0, filter.length)(a);
    const hueDoubleWrapped = a > b ? wrapInto(-180, 180)(hueWrapped) : void 0;
    const tuningPointA = filter[a];
    const tuningPointB = filter[b];
    const hueA = a > b ? wrapInto(-180, 180)(tuningPointA.hue) : tuningPointA.hue;
    const hueB = tuningPointB.hue;
    if ((hueDoubleWrapped || hueWrapped) >= hueA && (hueDoubleWrapped || hueWrapped) < hueB) {
      let $ = hueDoubleWrapped || hueWrapped;
      $ -= hueA;
      $ /= hueB - hueA;
      $ *= tuningPointB.sat - tuningPointA.sat;
      $ += tuningPointA.sat;
      Math.round($);
      maxSat = $;
    }
  }
  return maxSat;
};

// src/solveFor/satFromChannels.ts
var satFromChannels = ({ R, G, B }) => {
  const sat = Math.max(R, G, B) - Math.min(R, G, B);
  return sat;
};
var satFromChannels_default = satFromChannels;

// src/solveFor/specificLumFromHue.ts
var specificLumFromHue_default = (hue) => {
  const [factorR, factorG, factorB] = hueToRelativeChannels_default(hue);
  const lumR = CHANNEL_SPECIFIC_LUM.R * factorR;
  const lumG = CHANNEL_SPECIFIC_LUM.G * factorG;
  const lumB = CHANNEL_SPECIFIC_LUM.B * factorB;
  const specificLum = lumR + lumG + lumB;
  return specificLum;
};

// src/export/specToChannelsFixLimit.ts
var minChannelsForSaturationFromHue = (hue) => {
  const relativeChannels = hueToRelativeChannels_default(hue);
  const channelSpreader = (trueSaturation) => {
    const makeMinChannel = (idx) => Math.round(relativeChannels[idx] * trueSaturation);
    return {
      R: makeMinChannel(0),
      G: makeMinChannel(1),
      B: makeMinChannel(2)
    };
  };
  return channelSpreader;
};
var channelsFromIlluminationObj = ({
  minChannels,
  trueLuminosity,
  minLum
}) => {
  const { max, round } = Math;
  const maxWhite = 255 - max(...Object.values(minChannels));
  const white = clampInto(0, maxWhite)(round((trueLuminosity - minLum) * 255));
  const channels = {
    R: minChannels.R + white,
    G: minChannels.G + white,
    B: minChannels.B + white
  };
  return channels;
};
var specToChannelsFixLimit = ({ hue, sat, lum, prefer = `lum` }, filter = unfiltered) => {
  const minChannelsForSaturation = minChannelsForSaturationFromHue(hue);
  let trueSaturation;
  let trueLuminosity;
  let minChannels;
  let maxChannels;
  let specificLum;
  let minLum = 0;
  let maxLum = 1;
  let maxSat = maxSatForHueInFilter_default(hue, filter);
  switch (prefer) {
    case `sat`:
      trueSaturation = clampInto(0, 255)(Math.min(sat, maxSat));
      minChannels = minChannelsForSaturation(trueSaturation);
      maxChannels = {
        R: minChannels.R + 255 - trueSaturation,
        G: minChannels.G + 255 - trueSaturation,
        B: minChannels.B + 255 - trueSaturation
      };
      minLum = lumFromChannels_default(minChannels);
      maxLum = lumFromChannels_default(maxChannels);
      trueLuminosity = clampInto(minLum, maxLum)(lum);
      break;
    case `lum`:
      trueLuminosity = clampInto(0, 1)(lum);
      specificLum = specificLumFromHue_default(hue);
      maxSat = Math.min(
        maxSat,
        Math.round(
          trueLuminosity <= specificLum ? 255 * (trueLuminosity / specificLum) : 255 * (1 - trueLuminosity) / (1 - specificLum)
        )
      );
      trueSaturation = Math.min(sat, maxSat);
      minChannels = minChannelsForSaturation(trueSaturation);
      minLum = lumFromChannels_default(minChannels);
      break;
  }
  const channels = channelsFromIlluminationObj({
    minChannels,
    trueLuminosity,
    minLum
  });
  return {
    channels,
    fix: {
      sat: trueSaturation,
      lum: trueLuminosity
    },
    limit: {
      sat: [0, maxSat],
      lum: [prefer === `lum` ? 0 : minLum, maxLum]
    }
  };
};
var specToChannelsFixLimit_default = specToChannelsFixLimit;

// src/export/specToHexFixLimit.ts
var specToHexFixLimit = ({ hue, sat, lum, prefer }, filter) => {
  const { channels, fix, limit } = specToChannelsFixLimit_default(
    {
      hue,
      sat,
      lum,
      prefer
    },
    filter
  );
  const { R, G, B } = channels;
  const hex = channelsToHex_default({ R, G, B });
  return { hex, fix, limit };
};
var specToHexFixLimit_default = specToHexFixLimit;

// src/export/specToHex.ts
var specToHex = ({ hue, sat, lum, prefer }, filter) => {
  const { hex } = specToHexFixLimit_default({ hue, sat, lum, prefer }, filter);
  return hex;
};
var specToHex_default = specToHex;

// src/identify/hue.ts
var rangeNames = [
  { hue: 20, name: `red` },
  { hue: 45, name: `orange` },
  { hue: 61, name: `yellow` },
  { hue: 80, name: `citron` },
  { hue: 100, name: `lime` },
  { hue: 150, name: `green` },
  { hue: 180, name: `teal` },
  { hue: 200, name: `cyan` },
  { hue: 240, name: `blue` },
  { hue: 270, name: `indigo` },
  { hue: 300, name: `violet` },
  { hue: 330, name: `magenta` },
  { hue: 350, name: `pink` }
];
var identifyHue = (hue) => {
  const hueWrapped = wrapInto(0, 360)(hue);
  const { name } = rangeNames.find(({ hue: hue2 }) => hueWrapped >= hue2) || rangeNames[0];
  return name;
};

// src/import/channelsToSpec.ts
var channelsToSpec = ({ R, G, B }) => {
  const hue = hueFromChannels_default({ R, G, B });
  const sat = satFromChannels_default({ R, G, B });
  const lum = lumFromChannels_default({ R, G, B });
  return { hue, sat, lum };
};
var channelsToSpec_default = channelsToSpec;

// src/import/normalizeHex.ts
var BASE_16_CHAR_SET = `[a-fA-F0-9]+`;
var miniHexToHex = (miniHex) => {
  const miniHexArray = miniHex.split(``);
  const hexTemplate = [0, 0, 1, 1, 2, 2];
  return hexTemplate.map((idx) => miniHexArray[idx]).join(``);
};
var normalizeHex = (maybeHex) => {
  const hex = maybeHex.replace(/^#/, ``);
  const hexIsCorrectLength = hex.length === 6 || hex.length === 3;
  const hexIsCorrectCharSet = hex.match(new RegExp(`^${BASE_16_CHAR_SET}$`)) !== null;
  const hexIsValid = hexIsCorrectLength && hexIsCorrectCharSet;
  if (!hexIsValid) {
    throw new Error(`${maybeHex} is not a valid hex code`);
  }
  if (hex.length === 3) {
    return miniHexToHex(hex);
  }
  return hex;
};
var normalizeHex_default = normalizeHex;

// src/import/hexToChannels.ts
var hexToChannels_default = (maybeHex) => {
  const hex = normalizeHex_default(maybeHex);
  return {
    R: parseInt(hex.slice(0, 2), 16),
    G: parseInt(hex.slice(2, 4), 16),
    B: parseInt(hex.slice(4, 6), 16)
  };
};

// src/import/hexToSpec.ts
var hexToSpec = (hex) => {
  const { R, G, B } = hexToChannels_default(hex);
  const { hue, sat, lum } = channelsToSpec_default({ R, G, B });
  return { hue, sat, lum };
};
var hexToSpec_default = hexToSpec;

// ../anvl/src/function/pipe.ts
function pipe(a, ab, bc, cd, de, ef, fg, gh, hi) {
  switch (arguments.length) {
    case 1:
      return a;
    case 2:
      return ab(a);
    case 3:
      return bc(ab(a));
    case 4:
      return cd(bc(ab(a)));
    case 5:
      return de(cd(bc(ab(a))));
    case 6:
      return ef(de(cd(bc(ab(a)))));
    case 7:
      return fg(ef(de(cd(bc(ab(a))))));
    case 8:
      return gh(fg(ef(de(cd(bc(ab(a)))))));
    case 9:
      return hi(gh(fg(ef(de(cd(bc(ab(a))))))));
    default: {
      let ret = arguments[0];
      for (let i = 1; i < arguments.length; i++) {
        ret = arguments[i](ret);
      }
      return ret;
    }
  }
}

// ../anvl/src/function/index.ts
var become = (nextVersionOfThing) => (originalThing) => nextVersionOfThing instanceof Function ? nextVersionOfThing(
  originalThing instanceof Function ? originalThing() : originalThing
) : nextVersionOfThing;
var isModifier = (validate) => (sample) => {
  const sampleIsValid = validate(sample);
  if (!sampleIsValid) {
    throw new Error(`Invalid test case: JSON.stringify(${sample})`);
  }
  return (input) => {
    if (typeof input !== `function`)
      return false;
    const testResult = input(sample);
    return validate(testResult);
  };
};

// src/mixers/lum.ts
var resetColor = (color) => pipe(color, specToHex_default, hexToSpec_default, (hsl) => __spreadProps(__spreadValues({}, hsl), {
  prefer: color.prefer
}));
var setLum = (newLum) => (currentColor) => {
  const newColor = __spreadProps(__spreadValues({}, currentColor), {
    lum: pipe(currentColor.lum, become(newLum), clampInto(0, 1))
  });
  return newColor;
};
var tintBy = (tintAmount) => (color) => setLum((lum) => (lum * 100 + tintAmount) / 100)(resetColor(color));
var shadeBy = (shadeAmount) => (color) => setLum((lum) => (lum * 100 - shadeAmount) / 100)(resetColor(color));
var tint = (color, tintAmount) => tintBy(tintAmount)(color);
var shade = (color, shadeAmount) => shadeBy(shadeAmount)(color);

// src/mixers/sat.ts
var setSat = (newSat) => (currentColor) => {
  const newColor = __spreadProps(__spreadValues({}, currentColor), {
    sat: pipe(currentColor.sat, become(newSat), clampInto(0, 255))
  });
  console.log(newColor);
  return newColor;
};
var ampBy = (value) => (color) => setSat((sat) => sat + value)(color);
var muteBy = (value) => (color) => setSat((sat) => sat - value)(color);
var amp = (color, value) => ampBy(value)(color);
var mute = (color, value) => muteBy(value)(color);

// src/luum.ts
var Luum = class _Luum {
  constructor(json = {}) {
    this.prefer = `lum`;
    Object.assign(this, __spreadValues({ hue: 0, sat: 0, lum: 0, prefer: `lum` }, json));
  }
  toJSON() {
    return {
      hue: this.hue,
      sat: this.sat,
      lum: this.lum,
      prefer: this.prefer
    };
  }
  static fromJSON(json) {
    const isValid = isLuumSpec(json);
    if (isValid)
      return new _Luum(json);
    throw new Error(`Saved JSON for this Luum is invalid: ${json}`);
  }
  toHex() {
    return specToHex_default(this);
  }
  get hex() {
    return this.toHex();
  }
  shade(amount) {
    return new _Luum(shade(this, amount));
  }
  tint(amount) {
    return new _Luum(tint(this, amount));
  }
  amp(amount) {
    return new _Luum(amp(this, amount));
  }
  mute(amount) {
    return new _Luum(mute(this, amount));
  }
};

// src/mixers/hue.ts
var setHue = (newHue) => (currentColor) => {
  const newColor = __spreadProps(__spreadValues({}, currentColor), {
    hue: pipe(currentColor.hue, become(newHue), wrapInto(0, 360))
  });
  return newColor;
};
var trine = (value) => (color) => setHue((hue) => hue + value * 120)(color);
var tetra = (value) => (color) => setHue((hue) => hue + value * 90)(color);
var splitBy = (value) => (color) => setHue((hue) => hue + value * 150)(color);

// src/mixers/contrast.ts
var contrastMax = (color) => __spreadProps(__spreadValues({}, color), {
  lum: color.lum > 0.666 ? 0 : 1
});
var contrastStrong = (color) => __spreadProps(__spreadValues({}, color), {
  lum: color.lum > 0.666 ? 0.05 : 0.95
});
var contrastSoft = (color) => color.lum > 0.75 ? __spreadProps(__spreadValues({}, color), { lum: color.lum / 2 }) : color.lum < 0.25 ? __spreadProps(__spreadValues({}, color), { lum: color.lum + (1 - color.lum) / 2 }) : __spreadProps(__spreadValues({}, color), { lum: color.lum > 0.666 ? 1 : 0 });
var offset = (offsetAmount) => (color) => __spreadProps(__spreadValues({}, color), {
  lum: color.lum > 0.666 ? color.lum - offsetAmount : color.lum + offsetAmount
});

// ../anvl/src/array/index.ts
var each = (isType) => (input) => isType(input) ? [input] : Array.isArray(input) ? input.filter(isType) : [];
var isArray = (isType) => (input) => Array.isArray(input) && input.every((item) => isType(item));
var content = (isType) => (input) => isType(input) || isArray(isType)(input);
var join = (separator) => (a) => a.join(separator);
var map = (f) => (a) => a.map(f);
var every = (f = Boolean) => (a) => a.every(f);
var allTrue = every((x) => x === true);

// ../anvl/src/nullish/index.ts
var isUndefined = (input) => input === void 0;

// ../anvl/src/object/access.ts
var key = (k) => (obj) => obj[k];

// ../anvl/src/primitive/index.ts
var isString = (input) => {
  return typeof input === `string`;
};

// src/constants/luum-spec.ts
var defaultSpec = {
  hue: 0,
  lum: 0,
  sat: 0,
  prefer: `lum`
};

// src/scheme/index.ts
var CSS_PSEUDO_CLASSES = [
  `:active`,
  `:checked`,
  `:disabled`,
  `:enabled`,
  `:focus`,
  `:hover`,
  `:indeterminate`,
  `:visited`
];
var isCssPseudoClass = (s) => CSS_PSEUDO_CLASSES.includes(s);
var CSS_COLOR_PROPERTY_KEYS = [
  `background-color`,
  `background`,
  `border-bottom-color`,
  `border-color`,
  `border-left-color`,
  `border-right-color`,
  `border-top-color`,
  `border`,
  `box-shadow`,
  `caret-color`,
  `color`,
  `column-rule-color`,
  `column-rule`,
  `filter`,
  `opacity`,
  `outline-color`,
  `outline`,
  `text-decoration-color`,
  `text-decoration`,
  `text-shadow`,
  `fill`,
  `stroke`
];
var isCssColorPropertyKey = (input) => typeof input === `string` && (CSS_COLOR_PROPERTY_KEYS.includes(
  input
) || input.startsWith(`--`));
var isFilterPoint = (input) => typeof input === `object` && typeof input.hue === `number` && typeof input.sat === `number`;
var isFilter = (input) => isArray(isFilterPoint)(input);
var maybe = (validate) => (input) => isUndefined(input) || validate(input);
var isLuumSpec = (input) => typeof input === `object` && input !== null && typeof input.hue === `number` && typeof input.sat === `number` && typeof input.lum === `number` && [`sat`, `lum`].includes(input.prefer);
var isLuumSpecModifier = isModifier(isLuumSpec)(defaultSpec);
var isLuumCssAttribute = (input) => Array.isArray(input) && input.length === 2 && content(isCssColorPropertyKey)(input[0]) && content(isLuumSpecModifier)(input[1]);
var isLuumScssPseudoClassRule = (input) => input instanceof Array && input.length === 2 && content(isCssPseudoClass)(input[0]) && content(isLuumCssAttribute)(input[1]);
var isLuumScssNestedRule = (input) => input instanceof Array && input.length === 2 && content(isString)(input[0]) && content(isLuumCssAttribute)(input[1]);
var isLuumCssRule = (input) => typeof input === `object` && input !== null && isLuumSpec(input.root) && content(isLuumCssAttribute)(key(`attributes`)(input)) && maybe(content(isString))(key(`rootSelectors`)(input)) && maybe(isFilter)(key(`filter`)(input));
var isLuumScssRule = (input) => isLuumCssRule(input) && maybe(content(isLuumScssPseudoClassRule))(
  key(`states`)(input)
) && maybe(content(isLuumScssNestedRule))(key(`children`)(input));
var RED = {
  hue: 0,
  sat: 255,
  lum: 0.5,
  prefer: `sat`
};
var WAYFORGE_CORE_COLOR_NAMES = [
  `Red`,
  `Orange`,
  `Yellow`,
  `Lime`,
  `Green`,
  `Teal`,
  `Cyan`,
  `Blue`,
  `Indigo`,
  `Violet`,
  `Magenta`,
  `Pink`
];
var WAYFORGE_CORE_COLORS = WAYFORGE_CORE_COLOR_NAMES.reduce((acc, name, idx) => {
  acc[name] = {
    hue: idx * 30,
    sat: 255,
    lum: 0.5,
    prefer: `sat`
  };
  return acc;
}, {});
var PAINT_MY_WAGON_RED = {
  rootSelectors: [`.wagon`],
  root: RED,
  attributes: [`background-color`, shadeBy(5)],
  states: [
    [
      [`:hover`, `:focus`],
      [`background-color`, shadeBy(10)]
    ],
    [`:active`, [`background-color`, shadeBy(15)]]
  ]
};
var LF = `
`;
var luumToCss = (rule) => {
  const {
    attributes: oneOrManyAttributes,
    root,
    rootSelectors: maybeOneOrManyRootSelectors,
    filter: maybeFilter
  } = rule;
  const rootSelectors = pipe(
    maybeOneOrManyRootSelectors,
    each(isString),
    join(`, ` + LF),
    (s) => s ? s + ` {` + LF : ``
  );
  const attributes = pipe(
    oneOrManyAttributes,
    each(isLuumCssAttribute),
    map(([oneOrManyKeys, oneOrManyModifiers]) => {
      const modifiers = each(isLuumSpecModifier)(oneOrManyModifiers);
      const modifiedSpec = modifiers.reduce((last, modify) => modify(last), root);
      const hex = specToHex_default(modifiedSpec, maybeFilter);
      return pipe(
        oneOrManyKeys,
        each(isCssColorPropertyKey),
        map((key2) => `${key2}: ${hex}`),
        join(`; ` + LF)
      );
    }),
    join(`; ` + LF)
  );
  return rootSelectors ? join(LF)([rootSelectors, attributes, `}`]) : attributes;
};

// src/utils/interpolate.ts
var interpolate = ({
  completionRatio = 0.5,
  range: [to, from]
}) => {
  const value = from + completionRatio * (to - from);
  return value;
};
var interpolate_default = interpolate;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CHANNEL_SPECIFIC_LUM,
  CMYK,
  CSS_COLOR_PROPERTY_KEYS,
  CSS_PSEUDO_CLASSES,
  HUE_STRUCTURES,
  Luum,
  PAINT_MY_WAGON_RED,
  RED,
  UI,
  WAYFORGE_CORE_COLORS,
  WAYFORGE_CORE_COLOR_NAMES,
  amp,
  ampBy,
  channelsToSpec,
  contrastMax,
  contrastSoft,
  contrastStrong,
  hexToChannels,
  hexToSpec,
  hueFromChannels,
  hueToRelativeChannels,
  identifyHue,
  interpolate,
  isCssColorPropertyKey,
  isCssPseudoClass,
  isFilter,
  isFilterPoint,
  isLuumCssAttribute,
  isLuumCssRule,
  isLuumScssNestedRule,
  isLuumScssPseudoClassRule,
  isLuumScssRule,
  isLuumSpec,
  isLuumSpecModifier,
  lumFromChannels,
  luumToCss,
  maxSatForHueInFilter,
  maybe,
  mute,
  muteBy,
  normalizeHex,
  offset,
  palettes,
  resetColor,
  satFromChannels,
  setHue,
  setLum,
  setSat,
  shade,
  shadeBy,
  specToHex,
  specToHexFixLimit,
  specificLumFromHue,
  splitBy,
  tetra,
  tint,
  tintBy,
  trifactory,
  trine,
  unfiltered
});
